# Class PlainView

java.lang.Object
javax.swing.text.View
javax.swing.text.PlainView

All Implemented Interfaces:
  `SwingConstants, TabExpander`

Direct Known Subclasses:
  `FieldView`

public class PlainView extends View implements TabExpander
Implements View interface for a simple multi-line text view that has text in one font and color. The view represents each child element as a line of text.

See Also:
  - `View`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected FontMetrics`
  `metrics`
  Font metrics for the current font.

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlainView(Element elem)`
  Constructs a new PlainView wrapped on an element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `protected void`
  `damageLineRange(int line0, int line1, Shape a, Component host)`
  Repaint the given line range.
  `protected void`
  `drawLine(int lineIndex, Graphics2D g, float x, float y)`
  Renders a line of text, suppressing whitespace at the end and expanding any tabs.
  `protected void`
  `drawLine(int lineIndex, Graphics g, int x, int y)`
  Deprecated.
  replaced by `drawLine(int, Graphics2D, float, float)`
  `protected float`
  `drawSelectedText(Graphics2D g, float x, float y, int p0, int p1)`
  Renders the given range in the model as selected text.
  `protected int`
  `drawSelectedText(Graphics g, int x, int y, int p0, int p1)`
  Deprecated.
  replaced by `drawSelectedText(Graphics2D, float, float, int, int)`
  `protected float`
  `drawUnselectedText(Graphics2D g, float x, float y, int p0, int p1)`
  Renders the given range in the model as normal unselected text.
  `protected int`
  `drawUnselectedText(Graphics g, int x, int y, int p0, int p1)`
  Deprecated.
  replaced by `drawUnselectedText(Graphics2D, float, float, int, int)`
  `protected final Segment`
  `getLineBuffer()`
  Gives access to a buffer that can be used to fetch text from the associated document.
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `protected int`
  `getTabSize()`
  Returns the tab size set for the document, defaulting to 8.
  `void`
  `insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `protected Rectangle`
  `lineToRect(Shape a, int line)`
  Determine the rectangle that represents the given line.
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `float`
  `nextTabStop(float x, int tabOffset)`
  Returns the next tab stop position after a given reference position.
  `void`
  `paint(Graphics g, Shape a)`
  Renders using the given rendering surface and area on that surface.
  `void`
  `removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `protected void`
  `updateDamage(DocumentEvent changes, Shape a, ViewFactory f)`
  Repaint the region of change covered by the given document event.
  `protected void`
  `updateMetrics()`
  Checks to see if the font metrics and longest line are up-to-date.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class View

  `append, breakView, createFragment, forwardUpdate, forwardUpdateToView, getAlignment, getAttributes, getBreakWeight, getChildAllocation, getContainer, getDocument, getElement, getEndOffset, getGraphics, getMaximumSpan, getMinimumSpan, getNextVisualPositionFrom, getParent, getResizeWeight, getStartOffset, getToolTipText, getView, getViewCount, getViewFactory, getViewIndex, getViewIndex, insert, isVisible, modelToView, modelToView, preferenceChanged, remove, removeAll, replace, setParent, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location at which one might place a caret.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getResizeWeight(int axis)`
  Determines the resizability of the view along the given axis.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `View`
  `getView(int n)`
  Gets the nth child view.
  `int`
  `getViewCount()`
  Returns the number of views in this view.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping, for a given region, from the document model coordinate space to the view coordinate space.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  Child views can call this on the parent to indicate that the preference has changed and should be reconsidered for layout.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `void`
  `replace(int offset, int length, View[] views)`
  Replaces child views.
  `void`
  `setParent(View parent)`
  Establishes the parent view for this view.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### metrics

    protected FontMetrics metrics
    Font metrics for the current font.

- ## Constructor Details

  - ### PlainView

    public PlainView(Element elem)
    Constructs a new PlainView wrapped on an element.
    Parameters:
      `elem` - the element

- ## Method Details

  - ### getTabSize

    protected int getTabSize()
    Returns the tab size set for the document, defaulting to 8.
    Returns:
      the tab size

  - ### drawLine

    @Deprecated(since="9") protected void drawLine(int lineIndex, Graphics g, int x, int y)
    Deprecated.
    replaced by `drawLine(int, Graphics2D, float, float)`
    Renders a line of text, suppressing whitespace at the end and expanding any tabs. This is implemented to make calls to the methods `drawUnselectedText` and `drawSelectedText` so that the way selected and unselected text are rendered can be customized.
    Parameters:
      `lineIndex` - the line to draw >= 0
      `g` - the `Graphics` context
      `x` - the starting X position >= 0
      `y` - the starting Y position >= 0
    See Also:
      - `drawUnselectedText(Graphics, int, int, int, int)`
      - `drawSelectedText(Graphics, int, int, int, int)`

  - ### drawLine

    protected void drawLine(int lineIndex, Graphics2D g, float x, float y)
    Renders a line of text, suppressing whitespace at the end and expanding any tabs. This is implemented to make calls to the methods `drawUnselectedText` and `drawSelectedText` so that the way selected and unselected text are rendered can be customized.
    Parameters:
      `lineIndex` - the line to draw `>= 0`
      `g` - the `Graphics` context
      `x` - the starting X position `>= 0`
      `y` - the starting Y position `>= 0`
    Since:
      9
    See Also:
      - `drawUnselectedText(Graphics, int, int, int, int)`
      - `drawSelectedText(Graphics, int, int, int, int)`

  - ### drawUnselectedText

    @Deprecated(since="9") protected int drawUnselectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
    Deprecated.
    replaced by `drawUnselectedText(Graphics2D, float, float, int, int)`
    Renders the given range in the model as normal unselected text. Uses the foreground or disabled color to render the text.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate >= 0
      `y` - the starting Y coordinate >= 0
      `p0` - the beginning position in the model >= 0
      `p1` - the ending position in the model >= 0
    Returns:
      the X location of the end of the range >= 0
    Throws:
      `BadLocationException` - if the range is invalid

  - ### drawUnselectedText

    protected float drawUnselectedText(Graphics2D g, float x, float y, int p0, int p1) throws BadLocationException
    Renders the given range in the model as normal unselected text. Uses the foreground or disabled color to render the text.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate `>= 0`
      `y` - the starting Y coordinate `>= 0`
      `p0` - the beginning position in the model `>= 0`
      `p1` - the ending position in the model `>= 0`
    Returns:
      the X location of the end of the range `>= 0`
    Throws:
      `BadLocationException` - if the range is invalid
    Since:
      9

  - ### drawSelectedText

    @Deprecated(since="9") protected int drawSelectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
    Deprecated.
    replaced by `drawSelectedText(Graphics2D, float, float, int, int)`
    Renders the given range in the model as selected text. This is implemented to render the text in the color specified in the hosting component. It assumes the highlighter will render the selected background.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate >= 0
      `y` - the starting Y coordinate >= 0
      `p0` - the beginning position in the model >= 0
      `p1` - the ending position in the model >= 0
    Returns:
      the location of the end of the range
    Throws:
      `BadLocationException` - if the range is invalid

  - ### drawSelectedText

    protected float drawSelectedText(Graphics2D g, float x, float y, int p0, int p1) throws BadLocationException
    Renders the given range in the model as selected text. This is implemented to render the text in the color specified in the hosting component. It assumes the highlighter will render the selected background.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate `>= 0`
      `y` - the starting Y coordinate `>= 0`
      `p0` - the beginning position in the model `>= 0`
      `p1` - the ending position in the model `>= 0`
    Returns:
      the location of the end of the range
    Throws:
      `BadLocationException` - if the range is invalid
    Since:
      9

  - ### getLineBuffer

    protected final Segment getLineBuffer()
    Gives access to a buffer that can be used to fetch text from the associated document.
    Returns:
      the buffer

  - ### updateMetrics

    protected void updateMetrics()
    Checks to see if the font metrics and longest line are up-to-date.
    Since:
      1.4

  - ### getPreferredSpan

    public float getPreferredSpan(int axis)
    Determines the preferred span for this view along an axis.
    Specified by:
      `getPreferredSpan` in class `View`
    Parameters:
      `axis` - may be either View.X_AXIS or View.Y_AXIS
    Returns:
      the span the view would like to be rendered into >= 0. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
    Throws:
      `IllegalArgumentException` - for an invalid axis

  - ### paint

    public void paint(Graphics g, Shape a)
    Renders using the given rendering surface and area on that surface. The view may need to do layout and create child views to enable itself to render into the given allocation.
    Specified by:
      `paint` in class `View`
    Parameters:
      `g` - the rendering surface to use
      `a` - the allocated region to render into
    See Also:
      - `View.paint(Graphics, Shape)`

  - ### modelToView

    public Shape modelToView(int pos, Shape a, Position.Bias b) throws BadLocationException
    Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
    Specified by:
      `modelToView` in class `View`
    Parameters:
      `pos` - the position to convert >= 0
      `a` - the allocated region to render into
      `b` - the bias toward the previous character or the next character represented by the offset, in case the position is a boundary of two views; `b` will have one of these values:
      - `Position.Bias.Forward`
      - `Position.Bias.Backward`
    Returns:
      the bounding box of the given position
    Throws:
      `BadLocationException` - if the given position does not represent a valid location in the associated document
    See Also:
      - `View.modelToView(int, Shape, Position.Bias)`

  - ### viewToModel

    public int viewToModel(float x, float y, Shape a, Position.Bias[] bias)
    Provides a mapping from the view coordinate space to the logical coordinate space of the model.
    Specified by:
      `viewToModel` in class `View`
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `a` - the allocated region to render into
      `bias` - the returned bias
    Returns:
      the location within the model that best represents the given point in the view >= 0
    See Also:
      - `View.viewToModel(float, float, Shape, Position.Bias[])`

  - ### insertUpdate

    public void insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification that something was inserted into the document in a location that this view is responsible for.
    Overrides:
      `insertUpdate` in class `View`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.insertUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### removeUpdate

    public void removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification that something was removed from the document in a location that this view is responsible for.
    Overrides:
      `removeUpdate` in class `View`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.removeUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### changedUpdate

    public void changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification from the document that attributes were changed in a location that this view is responsible for.
    Overrides:
      `changedUpdate` in class `View`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.changedUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### setSize

    public void setSize(float width, float height)
    Sets the size of the view. This should cause layout of the view along the given axis, if it has any layout duties.
    Overrides:
      `setSize` in class `View`
    Parameters:
      `width` - the width >= 0
      `height` - the height >= 0

  - ### nextTabStop

    public float nextTabStop(float x, int tabOffset)
    Returns the next tab stop position after a given reference position. This implementation does not support things like centering so it ignores the tabOffset argument.
    Specified by:
      `nextTabStop` in interface `TabExpander`
    Parameters:
      `x` - the current position >= 0
      `tabOffset` - the position within the text stream that the tab occurred at >= 0.
    Returns:
      the tab stop, measured in points >= 0

  - ### updateDamage

    protected void updateDamage(DocumentEvent changes, Shape a, ViewFactory f)
    Repaint the region of change covered by the given document event. Damages the line that begins the range to cover the case when the insert/remove is only on one line. If lines are added or removed, damages the whole view. The longest line is checked to see if it has changed.
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    Since:
      1.4

  - ### damageLineRange

    protected void damageLineRange(int line0, int line1, Shape a, Component host)
    Repaint the given line range.
    Parameters:
      `line0` - the starting line number to repaint. This must be a valid line number in the model.
      `line1` - the ending line number to repaint. This must be a valid line number in the model.
      `a` - the region allocated for the view to render into
      `host` - the component hosting the view (used to call repaint)
    Since:
      1.4

  - ### lineToRect

    protected Rectangle lineToRect(Shape a, int line)
    Determine the rectangle that represents the given line.
    Parameters:
      `a` - the region allocated for the view to render into
      `line` - the line number to find the region of. This must be a valid line number in the model.
    Returns:
      the rectangle that represents the given line
    Since:
      1.4